Good Numbers
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3529 Accepted Submission(s): 1128
Problem Description
If we sum up every digit of a number and the result can be exactly divided by 10, we say this number is a good number.
You are required to count the number of good numbers in the range from A to B, inclusive.
Input
The first line has a number T (T <= 10000) , indicating the number of test cases.
Each test case comes with a single line with two numbers A and B (0 <= A <= B <= 10
18).
Output
For test case X, output "Case #X: " first, then output the number of good numbers in a single line.
Sample Input
Sample Output
Case #1: 0
Case #2: 1
Hint
The answer maybe very large, we recommend you to use long long instead of int.
Source
2013 ACM/ICPC Asia Regional Online —— Warmup2
题意:求a到b(并不包括b)之间共有多少个数能被10整除。
分析:基础题,dp[ i ][ j ]表示长度为 i 的数对10取模的值为 j 。
#include <iostream>
#include <cstdio>
#include <cstring>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;
const double eps = 1e-6;
const double pi = acos(-1.0);
const int INF = 0x3f3f3f3f;
const int MOD = 1000000007;
#define ll long long
#define CL(a) memset(a,0,sizeof(a))
ll s[20];
ll dp[20][10];//dp[i][j]表示长度为i的数对10取模为j
ll slove(ll x)
{
ll t=0,sum=0;
while (x)
{
s[++t]=x%10;
x/=10;
}
ll ans=0,m=0;
CL(dp);
for (int i=t; i>0; i--)//最高位开始枚举
{
for (int j=0; j<10; j++)//没有界限,枚举所有
for (int k=0; k<10; k++)
dp[i][(j+k)%10]+=dp[i+1][j];
for (int j=0; j<s[i]; j++)//有界限,如上一位为1,该位为2;而上一位已经是1了,所以该位只能取到2
dp[i][(j+m)%10]++;
m = (m+s[i])%10;//保存余数
}
if (!m) dp[1][0]++;
return dp[1][0];
}
int main ()
{
int T,ii=1;
ll a,b;
scanf ("%d",&T);
while (T--)
{
scanf ("%lld%lld",&a,&b);
printf ("Case #%d: %lld\n",ii++,slove(b)-slove(a-1));
}
return 0;
}